package com.pj.project.ocr;

import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.pj.project.ocr.bo.WordsResult;

import java.util.List;
import java.util.stream.Collectors;

/**
 * Created with IntelliJ IDEA.
 *
 * @Auther: lzm
 * @Date: 2022/08/26/15:32
 * @Description:
 */
public class etsete {

    public static void main(String[] args) {
        String resp = "{\n" +
                "    \"words_result\": [\n" +
                "        {\n" +
                "            \"words\": \"0024754\",\n" +
                "            \"location\": {\n" +
                "                \"top\": 364,\n" +
                "                \"left\": 251,\n" +
                "                \"width\": 297,\n" +
                "                \"height\": 64\n" +
                "            }\n" +
                "        },\n" +
                "        {\n" +
                "            \"words\": \"姓名：\",\n" +
                "            \"location\": {\n" +
                "                \"top\": 520,\n" +
                "                \"left\": 120,\n" +
                "                \"width\": 144,\n" +
                "                \"height\": 70\n" +
                "            }\n" +
                "        },\n" +
                "        {\n" +
                "            \"words\": \"宋永峰\",\n" +
                "            \"location\": {\n" +
                "                \"top\": 511,\n" +
                "                \"left\": 338,\n" +
                "                \"width\": 190,\n" +
                "                \"height\": 63\n" +
                "            }\n" +
                "        },\n" +
                "        {\n" +
                "            \"words\": \"男\",\n" +
                "            \"location\": {\n" +
                "                \"top\": 609,\n" +
                "                \"left\": 422,\n" +
                "                \"width\": 63,\n" +
                "                \"height\": 69\n" +
                "            }\n" +
                "        },\n" +
                "        {\n" +
                "            \"words\": \"性别：\",\n" +
                "            \"location\": {\n" +
                "                \"top\": 676,\n" +
                "                \"left\": 120,\n" +
                "                \"width\": 146,\n" +
                "                \"height\": 68\n" +
                "            }\n" +
                "        },\n" +
                "        {\n" +
                "            \"words\": \"身份证号码：450681198004042410\",\n" +
                "            \"location\": {\n" +
                "                \"top\": 823,\n" +
                "                \"left\": 127,\n" +
                "                \"width\": 981,\n" +
                "                \"height\": 69\n" +
                "            }\n" +
                "        },\n" +
                "        {\n" +
                "            \"words\": \"本证有效期\",\n" +
                "            \"location\": {\n" +
                "                \"top\": 1046,\n" +
                "                \"left\": 126,\n" +
                "                \"width\": 297,\n" +
                "                \"height\": 61\n" +
                "            }\n" +
                "        },\n" +
                "        {\n" +
                "            \"words\": \"自2021年01月01日起至2022年12月31日止\",\n" +
                "            \"location\": {\n" +
                "                \"top\": 1207,\n" +
                "                \"left\": 139,\n" +
                "                \"width\": 865,\n" +
                "                \"height\": 41\n" +
                "            }\n" +
                "        },\n" +
                "        {\n" +
                "            \"words\": \"发证单位：东兴市商务和口岸管理局\",\n" +
                "            \"location\": {\n" +
                "                \"top\": 1347,\n" +
                "                \"left\": 128,\n" +
                "                \"width\": 957,\n" +
                "                \"height\": 61\n" +
                "            }\n" +
                "        }\n" +
                "    ],\n" +
                "    \"words_result_num\": 9,\n" +
                "    \"log_id\": 1563055170558893628\n" +
                "}";
        JSONObject result = JSONUtil.parseObj(resp);
        String wordsResultJson = result.getStr("words_result");
        List<WordsResult> wordsResultList = JSONUtil.toList(wordsResultJson, WordsResult.class);
        List<String> wordsList = wordsResultList.stream().map(w -> w.getWords()).collect(Collectors.toList());

        int sexIndex  = 0;
        int nameIndex = 0;
        for (int i = 0; i < wordsList.size(); i++) {
            String currWord = wordsList.get(i);
            if(StrUtil.equals("男", currWord) || StrUtil.equals("女", currWord)){
                sexIndex = i;
            }
            if(StrUtil.contains(currWord, "性别")){
                nameIndex = i;
            }
        }
        if(nameIndex > sexIndex){
            String sex = wordsList.get(sexIndex);
            String name = wordsList.get(nameIndex);
            wordsList.set(nameIndex, sex);
            wordsList.set(sexIndex, name);
        }
        String words = wordsList.stream().map(String::valueOf).collect(Collectors.joining(""));
        System.out.println(words);
        String icId = StrUtil.sub(words, 0, 7);
        System.out.println(icId);
        int nameBeginIndex = StrUtil.indexOf(words, "姓名", 0, false);
        int nameEndIndex = StrUtil.indexOf(words, "性别", 0, false);
        String name = StrUtil.sub(words, nameBeginIndex+3, nameEndIndex);
        System.out.println(name);
        int idBeginIndex = StrUtil.indexOf(words, "身份证号码", 0, false);
        int idEndIndex = StrUtil.indexOf(words, "本证有效期自", 0, false);
        String idCard = StrUtil.sub(words, idBeginIndex+6, idEndIndex);
        System.out.println(idCard);
        int startTimeBeginIndex = StrUtil.indexOf(words, "本证有效期自", 0, false);
        int startTimeEndIndex = StrUtil.indexOf(words, "起至", 0, false);
        String startTime = StrUtil.sub(words, startTimeBeginIndex+6, startTimeEndIndex);
        System.out.println(startTime);
        int endTimeBeginIndex = StrUtil.indexOf(words, "起至", 0, false);
        int endTimeEndIndex = StrUtil.indexOf(words, "止发证单位", 0, false);
        String endTime = StrUtil.sub(words, endTimeBeginIndex+2, endTimeEndIndex);
        System.out.println(endTime);
    }

}
